param lamda >0;
param aobs ;
param bobs ;
param vobs ;
param M;
param varrange;
param deviance;
param tot;
param amatris {1..aobs,1..varrange};
param bmatris {1..bobs,1..varrange};
param vmatris {1..vobs,1..varrange};
param testt {j in 1..vobs};
var d {j in 1..vobs} binary;
var w{j in 1..varrange} ;
var y{j in 1..aobs} >= 0;
var z{j in 1..bobs} >=0;
var r{j in 1..vobs} >=0;
var s{j in 1..vobs} >=0;
var q{j in 1..varrange} >=0;
var gama;
 


minimize total:
(1-lamda)*(sum {j in 1..aobs} y[j])/(aobs+bobs+vobs) +
(1-lamda)*(sum {j in 1..bobs} z[j])/(aobs+bobs+vobs) +
(1-lamda)*(sum {j in 1..vobs} r[j])/(aobs+bobs+vobs) + 
(1-lamda)*(sum {j in 1..vobs} s[j])/(aobs+bobs+vobs) + 
lamda*(sum {j in 1..varrange} q[j])/2;

subject to cons1  {i in 1..aobs}:
sum {j in 1..varrange} (amatris[i,j] *w[j])-gama+y[i] >= 1;
subject to cons2  {i in 1..bobs}:
sum {j in 1..varrange} (-bmatris[i,j] *w[j])+gama+z[i] >= 1;
subject to cons3  {i in 1..vobs}:
sum {j in 1..varrange} (vmatris[i,j] *w[j])-gama+r[i]+M*d[i] >= 1;
subject to cons4  {i in 1..vobs}:
sum {j in 1..varrange} (-vmatris[i,j] *w[j])+gama+s[i]+M*(1-d[i]) >= 1;

subject to cons5  {i in 1..varrange}:
-q[i]<=w[i];
subject to cons6  {i in 1..varrange}:
w[i]<=q[i];




 

